package com.qmth.sxufe.utils;

import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

public class CasUtils {

    public static String getBasePath(HttpServletRequest request) {
        String scheme = request.getScheme();
        String serverName = request.getServerName();
        int serverPort = request.getServerPort();
        String contextPath = request.getContextPath();

        // 判断是否配置了显式端口
        boolean explicit_port = Constants.CLIENT_SYSTEM_EXPLICIT_PORT != null
                && !"".equals(Constants.CLIENT_SYSTEM_EXPLICIT_PORT);

        if (explicit_port) {
            try {
                serverPort = Integer
                        .parseInt(Constants.CLIENT_SYSTEM_EXPLICIT_PORT);
            } catch (Exception e) {

                // 异常时赋值，方便双方排查问题
                serverPort = 19000;
            }

            String url = scheme + "://" + serverName + ":" + serverPort
                    + contextPath + "/";
            return url;

        } else {
            if ((serverPort == 80) || (serverPort == 443)) {

                String url = scheme + "://" + serverName + contextPath;
                return url;
            } else {
                String url = scheme + "://" + serverName + ":" + serverPort + contextPath;
                return url;
            }
        }

    }

    /**
     * 获取TargetUrl
     */
    public static String getTargetUrl(HttpServletRequest request) {
        String basePath = getBasePath(request);

        // 使用默认页面作为targetUrl
        return basePath + Constants.DEF_TARGET_URI;
    }

//    public static String getURLEncodeServiceUrl(HttpServletRequest request)
//            throws UnsupportedEncodingException {
//
//        // 编码成系统可识别的加密串
//        String targetUrl = getTargetUrl(request);
//        String base64TargetUrl = Base64Utils.encodeBase64Str(targetUrl);
//
//        String serviceUrlRoot = getBasePath(request)
//                + Constants.SSO_LOGIN_URI;
//
//        String serviceUrl = serviceUrlRoot + "?" + Constants.TARGET_URL_KEY
//                + "=" + Constants.BASE64_PREFIX + base64TargetUrl;
//        return URLEncoder.encode(serviceUrl, Constants.UTF_8_STR);
//    }

    /**
     * 获取Cas登录Url 登录成功后返回票据
     */
//    public static String getLoginUrl(HttpServletRequest request)
//            throws UnsupportedEncodingException {
//        String encodeServiceUrl = getURLEncodeServiceUrl(request);
//
//        return Constants.CAS_LOGIN_URL + "?" + Constants.SERVICE_KEY + "="
//                + encodeServiceUrl;
//    }

    /**
     * 获取登出地址
     */
    public static String getLogoutUrl(HttpServletRequest request)
            throws UnsupportedEncodingException {
        // 获取本次请求的根Path
        String loginUrlRoot = getBasePath(request)
                + Constants.SSO_LOGIN_URI;
        String encodeLoginUrlRoot = URLEncoder.encode(loginUrlRoot,
                Constants.UTF_8_STR);
        return Constants.CAS_LOGOUT_URL + "?" + Constants.SERVICE_KEY + "="
                + encodeLoginUrlRoot;
    }

}
